//=============================================================================   
// All the code below are provided for demo purpose only.   
// It'll be on your own risk if you like to adopt all or parts of the code into   
// your own application.   
//   
// This module implements all the functions needed for boot-loader   
//   
// All the codes must be put into a specific segment called "text_bootload".   
// This segment is defined in linker-config-file (.lcf) for special positioning   
// It'll be resided in Flash memory permanently as a basic driver. It can only   
// be reprogrammed by hardware programming tools such as BDM   
//   
// Designed by Paul Zhang (paul.zhang@freescale.com)   
// May 10, 2008    
//=============================================================================   
   
#include <hidef.h>        // for EnableInterrupts macro   
#include "derivative.h"   // include peripheral declarations   
   
//=============================================================================   
// Declare function reference   
//=============================================================================   
void StartupEntry(void); // First vector entry, declared in "VectorMap.c"   
void BootLoader(void);   // Bootload routine, defined in this module   
   
//=============================================================================   
// External lable referred in this module   
// They are all defined in 'project.lcf' file   
//=============================================================================   
extern unsigned long far _SP_INIT, _SDA_BASE;   
   
//=============================================================================   
// Declare a code segment with name "text_bootload"   
//=============================================================================   
#pragma CODE_SEG __FAR_SEG text_bootload   

//=============================================================================   
// Boot-loader main routine   
//=============================================================================   
void BootLoader(void)   
{   
   //setup A7 stack pointer   
   asm (lea      _SP_INIT, a7);   
    //setup A6 dummy stackframe   
   asm (movea.l  #0, a6);   
   asm (link     a6, #0);   
    //setup A5   
   asm (lea      _SDA_BASE, a5);   
   
   //Boot-loader main loop    
   for (;;) {   
   }   
}   
   
